clear
close all

% original image
I=imread('/Users/marcel/Documents/MATLAB/0-images-exemples/materiaux/serveimage-8.jpeg');
I_int=rgb2gray(I);
mean_int = mean(mean(I_int));

figure(1)
subplot(2,4,1), imagesc(I_int), colormap(gray), colorbar, axis('image')
title({'image originale' ; ['mean=',int2str(mean_int)]})
subplot(2,4,2), imhist(I_int, 256), axis('square')

% equalized image (256)
n=256
I_eq = histeq(I_int, n);
mean_eq = mean(mean(I_eq));

subplot(2,4,3), imagesc(I_eq), colormap(gray), colorbar, axis('image')
title({'image galise (256 niv.)' ; ['mean=',int2str(mean_eq)]})
subplot(2,4,4), imhist(I_eq, n), axis('square')

% "adjusted" image
I_adj = imadjust(I_int);
mean_adj = mean(mean(I_adj));

subplot(2,4,5), imagesc(I_adj), colormap(gray), colorbar, axis('image')
title({'image ''ajuste'' [0,255/255]' ; ['mean=',int2str(mean_adj)]})
subplot(2,4,6), imhist(I_adj, 256), axis('square')

% "adjusted" image with selected input range to adjust
I_adj2 = imadjust(I_int, [0., 20./255], []);
mean_adj2 = mean(mean(I_adj2));

subplot(2,4,7), imagesc(I_adj2), colormap(gray), colorbar, axis('image')
title({'image ''ajuste'' [0, 20/255]' ; ['mean=',int2str(mean_adj2)]})

subplot(2,4,8), imhist(I_adj2, 256), axis('square')