clear
close all

frog = imread('/Users/marcel/Documents/MATLAB/0-images-exemples/classiques/frog.jpg');

% image originale
frog_int = rgb2gray(frog);
'type de frog_int :', whos frog_int
min_int = min(min(frog_int)); max_int = max(max(frog_int));
[n_int,x_int]=imhist(frog_int,256);

figure
subplot(4,3,1), imagesc(frog_int), colormap(gray), colorbar, axis('image')
title({'image originale';['min=',int2str(min_int),' max=',int2str(max_int)]})
subplot(4,3,2), imhist(frog_int,256)
%subplot(4,3,3), plot(x_int, n_int-n_int), xlim([0 255])

% bruit de photon
frog_pho = imnoise(frog_int, 'poisson');
'type de frog_pho :', whos frog_pho
min_pho = min(min(frog_pho)); max_pho = max(max(frog_pho));
dist_im   = sqrt(sum(sum((frog_pho-frog_int).^2)))
[n_pho,x_pho]=imhist(frog_pho,256);
dist_hist = sqrt(sum(sum((n_pho-n_int).^2)))

subplot(4,3,4), imagesc(frog_pho), colormap(gray), colorbar, axis('image')
title({'photonisation' ; ['min=',int2str(min_pho),' max=',int2str(max_pho),' dist=',int2str(dist_im)]})
subplot(4,3,5), imhist(frog_pho,256)
subplot(4,3,6), plot(x_pho, n_pho-n_int), xlim([0 255]), title(['dist=',int2str(dist_hist)])

% bruit poivre & sel
frog_snp = imnoise(frog_pho, 'salt & pepper', 0.05);
'type de frog_snp :', whos frog_snp
min_snp = min(min(frog_snp)); max_snp = max(max(frog_snp));
dist_im   = sqrt(sum(sum((frog_snp-frog_pho).^2)))
[n_snp,x_snp]=imhist(frog_snp,256);
dist_hist = sqrt(sum(sum((n_snp-n_pho).^2)))

subplot(4,3,7), imagesc(frog_snp), colormap(gray), colorbar, axis('image')
title({'poivre et sel' ; ['min=',int2str(min_snp),' max=',int2str(max_snp),' dist=',int2str(dist_im)]})
subplot(4,3,8), imhist(frog_snp,256)
subplot(4,3,9), plot(x_snp, n_snp-n_pho), xlim([0 255]), title(['dist=',int2str(dist_hist)])

% bruit de lecture
frog_ree = double(frog_snp)/255.;
frog_ron = imnoise(frog_ree, 'gaussian', 0., .01);
'type de frog_ron :', whos frog_ron
min_ron = min(min(frog_ron)); max_ron = max(max(frog_ron));
dist_im   = sqrt(sum(sum((frog_ron-double(frog_snp)/255.).^2)))
[n_ron,x_ron]=imhist(frog_ron,256);
dist_hist = sqrt(sum(sum((n_ron-n_snp).^2)))

subplot(4,3,10), imagesc(frog_ron), colormap(gray), colorbar, axis('image')
title({'frog\_ron' ; ['min=',int2str(min_ron),' max=',int2str(max_ron),' dist=',int2str(dist_im)]})
subplot(4,3,11), imhist(frog_ron,256)
subplot(4,3,12), plot(x_ron, n_ron-n_snp), xlim([0 1]), title(['dist=',int2str(dist_hist)])