clear
close all

% image de la grenouille
img='/Users/marcel/Documents/MATLAB/0-images-exemples/classiques/frog.jpg';
frog=imread(img);
I=rgb2gray(frog);
I=double(I)/255.;

% filtre de Prewitt
Ph=fspecial('prewitt');
Pv=-Ph';
IPh=filter2(Ph,I);
IPv=filter2(Pv,I);
IPvh=sqrt(IPv.^2+IPh.^2);

figure(1)
colormap('gray')
subplot(2,3,1), imagesc(IPv), colorbar, title('Prewitt vertical')
axis('square')
subplot(2,3,2), imagesc(IPh), colorbar, title('Prewitt horizontal')
axis('square')
subplot(2,3,3), imagesc(IPvh),colorbar, title('Prewitt complet')
axis('square')

% filtre de Sobel
Sh=fspecial('sobel');
Sv=-Sh';
ISh=filter2(Sh,I);
ISv=filter2(Sv,I);
ISvh=sqrt(ISv.^2+ISh.^2);

subplot(2,3,4), imagesc(ISv), colorbar, title('Sobel vertical')
axis('square')
subplot(2,3,5), imagesc(ISh), colorbar, title('Sobel horizontal')
axis('square')
subplot(2,3,6), imagesc(ISvh),colorbar, title('Sobel complet')
axis('square')

% seuillage Prewitt et comparaison avec ajustement seuil Sobel
seuil=0.8;
IPs=(IPvh>seuil);
ISs=(ISvh>seuil);

'dynamique :', max(max(ISvh))/max(max(IPvh))

seuil=1.08;
ISs2=(ISvh>seuil);

figure(2)
colormap('gray')
subplot(1,3,1), imagesc(IPs), colorbar, title('Prewitt avec seuil')
axis('square')
subplot(1,3,2), imagesc(ISs), colorbar, title('Sobel avec mme seuil')
axis('square')
subplot(1,3,3), imagesc(ISs2), colorbar, title('Sobel avec seuil ajust')
axis('square')