clear
close all

% load image from disk
load image_bruit, whos J
figure(1), colormap(gray)
subplot(2,4,1), imagesc(J), title('image test'), colorbar, axis('square')

%---
% Prewitt
Ph=fspecial('prewitt'); Pv=-Ph'; JP=filter2(Pv,J, 'valid');
subplot(2,4,2), imagesc(JP), title('Prewitt'), colorbar, axis('square')
% seuillage
seuilP=0.25; JPs=JP>seuilP;
subplot(2,4,6),imagesc(JPs),title('Prewitt+seuil'),colorbar,axis('square')

%---
% Sobel
Sh=fspecial('sobel'); Sv=-Sh'; JS=filter2(Sv,J, 'valid');
subplot(2,4,3),imagesc(JS), title('Sobel'), colorbar, axis('square')
% seuillage
seuilS=.367; JSs=JS>seuilS;
subplot(2,4,7),imagesc(JSs),title('Sobel+seuil'),colorbar,axis('square')

%---
% Roberts
Ra=[1 0;0 -1]; Rb=rot90(Ra,-1);
JRa=filter2(Ra,J, 'valid'); JRb=filter2(Rb,J, 'valid');
JR=sqrt(JRa.*JRa+JRb.*JRb);
subplot(2,4,4), imagesc(JR), title('Roberts'), colorbar, axis('square')
% seuillage
seuilR=.175; JRs=JR>seuilR;
subplot(2,4,8),imagesc(JRs),title('Roberts+seuil'),colorbar,axis('square')

%---
% mise en vidence du contour
sumP=sum(JPs); sumS=sum(JSs); sumR=sum(JRs);

dim=128;
% dtections autour du contour
{'-------------------------' ;
 'Dtections de contours...' ;
 '-------------------------' ;
 ['Prewitt : ', int2str(sumP(dim/2-2:dim/2+3))] ;
 ['Sobel   : ', int2str(sumS(dim/2-2:dim/2+3))] ;
 ['Roberts : ', int2str(sumR(dim/2-2:dim/2+3))] ;
 '-------------------------' }

figure(2)
subplot(1,3,1), plot(sumP), axis('square'), title('Prewitt')
subplot(1,3,2), plot(sumS), axis('square'), title('Sobel')
subplot(1,3,3), plot(sumR), axis('square'), title('Roberts')

% fausses alarmes
{'------------------' ;
 'Fausses alarmes...' ;
 '------------------' ;
 ['Prewitt : ', num2str(sum(sumP(1:dim/2-2))+sum(sumP(dim/2+1:end)))] ;
 ['Sobel   : ', num2str(sum(sumS(1:dim/2-2))+sum(sumS(dim/2+1:end)))] ;
 ['Roberts : ', num2str(sum(sumR(1:dim/2-1))+sum(sumR(dim/2+1:end)))] ;
 '------------------' }

% => probabilits de fausse alarme
{'-----------------------------------' ;
 '=> Probabilits de fausse alarme...' ;
 '-----------------------------------' ;
 ['Prewitt : ', num2str((sum(sumP(1:dim/2-2))+sum(sumP(dim/2+1:end)))/(dim-2)^2)] ;
 ['Sobel   : ', num2str((sum(sumS(1:dim/2-2))+sum(sumS(dim/2+1:end)))/(dim-2)^2)] ;
 ['Roberts : ', num2str((sum(sumR(1:dim/2-1))+sum(sumR(dim/2+1:end)))/(dim-1)^2)] ;
 '-----------------------------------' }

% => probabilits de dtection
{'-------------------------------' ;
 '=> Probabilits de dtection...' ;
 '-------------------------------' ;
 ['Prewitt : ', num2str(sum(sumP(dim/2-1:dim/2))/(2*(dim-2)))] ;
 ['Sobel   : ', num2str(sum(sumS(dim/2-1:dim/2))/(2*(dim-2)))] ;
 ['Roberts : ', num2str(sum(sumR(dim/2))/(dim-2))] ;
 '-------------------------------' }